"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.mill = exports.collect = collect;
exports.Collect = void 0;

var _reducer = require("./reducer");

var _combine = require("./combine");

class Collect {
  and(red) {
    return new Collect([...this.parts, red]);
  }

  combine(fn) {
    var reducers = this.parts.length === 0 ? [(0, _reducer.createReducer)()] : this.parts;
    var join = _combine.combine;
    var joined = join(fn, ...reducers);
    return joined;
  }

  joint(fn) {
    return this.combine(fn);
  }

  constructor(parts = []) {
    this.parts = parts;
  }

}

exports.Collect = Collect;

function collect() {
  return new Collect();
}
//# sourceMappingURL=collect.js.map